W(1)

NAME
w - who present users are and what they are doing

SYNOPSIS
w [-hinw] [-M core] [-N system] [user]

DESCRIPTION
The w utility prints a summary of the current activity on the system, including what each user is doing. The first line displays the current time of day, how long the system has been running, the number of users logged into the system, and the load averages. The load average numbers give the number of jobs in the run queue averaged over 1, 5, and 15 minutes. The load average is obtained using getloadavg(3).

The fields output are the user's login name, the name of the terminal the user is on, the host from which the user is logged in, the time the user logged on, the time since the user last typed anything, and the name and arguments of the current process.

The options are as follows:

-h  Suppress the heading.

-i  Output is sorted by idle time.

-M  Extract values associated with the name list from the specified core instead of the default “/dev/kmem”.

-N  Extract the name list from the specified system instead of the default “/netbsd”.

-n  Show network addresses as numbers (normally w interprets addresses and attempts to display them symbolically).

-w  Show wide output without truncating any fields.

If a user name is specified, the output is restricted to that user.

FILES
/var/run/utmp
    list of users on the system

SEE ALSO
finger(1), ps(1), uptime(1), who(1), getloadavg(3)

HISTORY
The w command appeared in 3.0BSD.

BUGS
The notion of the “current process” is muddy. The current algorithm is ``the highest numbered process on the terminal that is not ignoring interrupts, or, if there is none, the highest numbered process on the terminal''. This fails, for example, in critical sections of programs like the shell and editor, or when faulty programs running in the background fork and fail to ignore interrupts. (In cases where no process can be found, w prints “-”.)

Background processes are not shown, even though they account for much of the load on the system.

Sometimes processes, typically those in the background, are printed with null or garbaged arguments. In these cases, the name of the command is printed in parentheses.

The w utility does not know about the new conventions for detection of background jobs. It will sometimes find a background job instead of the right one.